Main Page Class Hierarchy Alphabetical List Compound List File List Compound Members File Members Related Pages

# ACE_WIN32_Proactor Class Reference

A manager for asynchronous event demultiplexing. More...

`#include <WIN32_Proactor.h>`

Inheritance diagram for ACE_WIN32_Proactor

[legend]
Collaboration diagram for ACE_WIN32_Proactor:

[legend]
List of all members.

## Public Methods
| ACE_WIN32_Proactor (size_t number_of_threads = 0, int used_with_reactor_event_loop = 0)
| A do nothing constructor.
virtual | ~ACE_WIN32_Proactor (void)
| Virtual destruction.
virtual int | close (void)
| Close the IO completion port.
virtual int | register_handle (ACE_HANDLE handle, const void *completion_key)
| This method adds the <handle> to the I/O completion port. This function is a no-op function for Unix systems.
virtual int | handle_events (ACE_Time_Value &wait_time)
virtual int | handle_events (void)
virtual int | post_completion (ACE_WIN32_Asynch_Result *result)
int | wake_up_dispatch_threads (void)
| Add wakeup dispatch threads (reinit).
int | close_dispatch_threads (int wait)
| Close all dispatch threads.
size_t | number_of_threads (void) const
| Number of thread used as a parameter to CreatIoCompletionPort.
void | number_of_threads (size_t threads)
virtual ACE_HANDLE | get_handle (void) const
| Get the event handle.
virtual ACE_Asynch_Read_Stream_Impl* | create_asynch_read_stream (void)
| Create the correct implementation class for doing Asynch_Read_Stream.
virtual ACE_Asynch_Write_Stream_Impl* | create_asynch_write_stream (void)
| Create the correct implementation class for doing Asynch_Write_Stream.
virtual ACE_Asynch_Read_File_Impl* | create_asynch_read_file (void)
| Create the correct implementation class for doing Asynch_Read_File.
virtual ACE_Asynch_Write_File_Impl* | create_asynch_write_file (void)
| Create the correct implementation class for doing Asynch_Write_File.
virtual ACE_Asynch_Read_Dgram_Impl* | create_asynch_read_dgram (void)
| Create the correct implementation class for doing Asynch_Read_Dgram.
virtual ACE_Asynch_Write_Dgram_Impl* | create_asynch_write_dgram (void)
| Create the correct implementation class for doing Asynch_Write_Dgram.
virtual ACE_Asynch_Accept_Impl* | create_asynch_accept (void)
| Create the correct implementation class for doing Asynch_Accept.
virtual ACE_Asynch_Transmit_File_Impl* | create_asynch_transmit_file (void)
| Create the correct implementation class for doing Asynch_Transmit_File.
virtual ACE_Asynch_Read_Stream_Result_Impl* | create_asynch_read_stream_result (ACE_Handler &handler, ACE_HANDLE handle, ACE_Message_Block &message_block, u_long bytes_to_read, const void* act, ACE_HANDLE event, int priority, int signal_number = 0)
| Create the correct implementation class for ACE_Asynch_Read_Stream::Result class.
virtual ACE_Asynch_Write_Stream_Result_Impl* | create_asynch_write_stream_result (ACE_Handler &handler, ACE_HANDLE handle, ACE_Message_Block &message_block, u_long bytes_to_write, const void* act, ACE_HANDLE event, int priority, int signal_number = 0)
| Create the correct implementation class for ACE_Asynch_Write_Stream::Result.
virtual ACE_Asynch_Read_File_Result_Impl* | create_asynch_read_file_result (ACE_Handler &handler, ACE_HANDLE handle, ACE_Message_Block &message_block, u_long bytes_to_read, const void* act, u_long offset, u_long offset_high, ACE_HANDLE event, int priority, int signal_number = 0)
| Create the correct implementation class for ACE_Asynch_Read_File::Result.
virtual ACE_Asynch_Write_File_Result_Impl* | create_asynch_write_file_result (ACE_Handler &handler, ACE_HANDLE handle, ACE_Message_Block &message_block, u_long bytes_to_write, const void* act, u_long offset, u_long offset_high, ACE_HANDLE event, int priority, int signal_number = 0)
| Create the correct implementation class for ACE_Asynch_Write_File::Result.
virtual ACE_Asynch_Read_Dgram_Result_Impl* | create_asynch_read_dgram_result (ACE_Handler &handler, ACE_HANDLE handle, ACE_Message_Block *message_block, size_t bytes_to_read, int flags, int protocol_family, const void* act, ACE_HANDLE event, int priority, int signal_number = 0)
| Create the correct implementation class for ACE_Asynch_Read_Dgram::Result.
virtual ACE_Asynch_Write_Dgram_Result_Impl* | create_asynch_write_dgram_result (ACE_Handler &handler, ACE_HANDLE handle, ACE_Message_Block *message_block, size_t bytes_to_write, int flags, const void* act, ACE_HANDLE event, int priority, int signal_number = 0)
| Create the correct implementation class for ACE_Asynch_Write_Dgram::Result.
virtual ACE_Asynch_Accept_Result_Impl* | create_asynch_accept_result (ACE_Handler &handler, ACE_HANDLE listen_handle, ACE_HANDLE accept_handle, ACE_Message_Block &message_block, u_long bytes_to_read, const void* act, ACE_HANDLE event, int priority, int signal_number = 0)
| Create the correct implementation class for ACE_Asynch_Accept::Result.
virtual ACE_Asynch_Transmit_File_Result_Impl* | create_asynch_transmit_file_result (ACE_Handler &handler, ACE_HANDLE socket, ACE_HANDLE file, ACE_Asynch_Transmit_File::Header_And_Trailer *header_and_trailer, u_long bytes_to_write, u_long offset, u_long offset_high, u_long bytes_per_send, u_long flags, const void *act, ACE_HANDLE event, int priority, int signal_number = 0)
| Create the correct implementation class for ACE_Asynch_Transmit_File::Result.
virtual ACE_Asynch_Result_Impl* | create_asynch_timer (ACE_Handler &handler, const void *act, const ACE_Time_Value &tv, ACE_HANDLE event, int priority, int signal_number = 0)
| Create a timer result object which can be used with the Timer mechanism of the Proactor.
## Protected Methods
virtual int | handle_signal (int signum, siginfo_t * = 0, ucontext_t * = 0)
| Called when object is signaled by OS (either via UNIX signals or when a Win32 object becomes signaled).
virtual int | handle_close (ACE_HANDLE handle, ACE_Reactor_Mask close_mask)
| Called when object is removed from the ACE_Reactor.
virtual int | handle_events (unsigned long milli_seconds)
void | application_specific_code (ACE_WIN32_Asynch_Result *asynch_result, u_long bytes_transferred, int success, const void *completion_key, u_long error)
| Protect against structured exceptions caused by user code when dispatching handles.
virtual int | post_wakeup_completions (int how_many)
## Protected Attributes
ACE_HANDLE | completion_port_
| Handle for the completion port. Unix doesnt have completion ports.
size_t | number_of_threads_
| This number is passed to the <CreatIOCompletionPort> system call.
ACE_Auto_Event | event_
| This event is used in conjunction with Reactor when we try to integrate the event loops of Reactor and the Proactor.
int | used_with_reactor_event_loop_
| Flag that indicates whether we are used in conjunction with Reactor.
ACE_Handler | wakeup_handler_
| Handler to handle the wakeups. This works in conjunction with the .

## Detailed Description

A manager for asynchronous event demultiplexing.

See the Proactor pattern description at http://www.cs.wustl.edu/~schmidt/proactor.ps.gz for more details.

## Constructor & Destructor Documentation

ACE_WIN32_Proactor::ACE_WIN32_Proactor ( | size_t number_of_threads = 0,
| int used_with_reactor_event_loop = 0 )

| A do nothing constructor.

ACE_WIN32_Proactor::~ACE_WIN32_Proactor ( | void )`[virtual]`

| Virtual destruction.

## Member Function Documentation

void ACE_WIN32_Proactor::application_specific_code ( | ACE_WIN32_Asynch_Result * asynch_result,
| u_long bytes_transferred,
| int success,
| const void * completion_key,
| u_long error )`[protected]`

| Protect against structured exceptions caused by user code when dispatching handles.

int ACE_WIN32_Proactor::close ( | void )`[virtual]`

| Close the IO completion port. Reimplemented from ACE_Proactor_Impl.

int ACE_WIN32_Proactor::close_dispatch_threads ( | int wait )`[virtual]`

| Close all dispatch threads. Reimplemented from ACE_Proactor_Impl.

ACE_Asynch_Accept_Impl * ACE_WIN32_Proactor::create_asynch_accept ( | void )`[virtual]`

| Create the correct implementation class for doing Asynch_Accept. Reimplemented from ACE_Proactor_Impl.

ACE_Asynch_Accept_Result_Impl * ACE_WIN32_Proactor::create_asynch_accept_result ( | ACE_Handler & handler,
| ACE_HANDLE listen_handle,
| ACE_HANDLE accept_handle,
| ACE_Message_Block & message_block,
| u_long bytes_to_read,
| const void * act,
| ACE_HANDLE event,
| int priority,
| int signal_number = 0 )`[virtual]`

| Create the correct implementation class for ACE_Asynch_Accept::Result. Reimplemented from ACE_Proactor_Impl.

ACE_Asynch_Read_Dgram_Impl * ACE_WIN32_Proactor::create_asynch_read_dgram ( | void )`[virtual]`

| Create the correct implementation class for doing Asynch_Read_Dgram. Reimplemented from ACE_Proactor_Impl.

ACE_Asynch_Read_Dgram_Result_Impl * ACE_WIN32_Proactor::create_asynch_read_dgram_result ( | ACE_Handler & handler,
| ACE_HANDLE handle,
| ACE_Message_Block * message_block,
| size_t bytes_to_read,
| int flags,
| int protocol_family,
| const void * act,
| ACE_HANDLE event,
| int priority,
| int signal_number = 0 )`[virtual]`

| Create the correct implementation class for ACE_Asynch_Read_Dgram::Result. Reimplemented from ACE_Proactor_Impl.

ACE_Asynch_Read_File_Impl * ACE_WIN32_Proactor::create_asynch_read_file ( | void )`[virtual]`

| Create the correct implementation class for doing Asynch_Read_File. Reimplemented from ACE_Proactor_Impl.

ACE_Asynch_Read_File_Result_Impl * ACE_WIN32_Proactor::create_asynch_read_file_result ( | ACE_Handler & handler,
| ACE_HANDLE handle,
| ACE_Message_Block & message_block,
| u_long bytes_to_read,
| const void * act,
| u_long offset,
| u_long offset_high,
| ACE_HANDLE event,
| int priority,
| int signal_number = 0 )`[virtual]`

| Create the correct implementation class for ACE_Asynch_Read_File::Result. Reimplemented from ACE_Proactor_Impl.

ACE_Asynch_Read_Stream_Impl * ACE_WIN32_Proactor::create_asynch_read_stream ( | void )`[virtual]`

| Create the correct implementation class for doing Asynch_Read_Stream. Reimplemented from ACE_Proactor_Impl.

ACE_Asynch_Read_Stream_Result_Impl * ACE_WIN32_Proactor::create_asynch_read_stream_result ( | ACE_Handler & handler,
| ACE_HANDLE handle,
| ACE_Message_Block & message_block,
| u_long bytes_to_read,
| const void * act,
| ACE_HANDLE event,
| int priority,
| int signal_number = 0 )`[virtual]`

| Create the correct implementation class for ACE_Asynch_Read_Stream::Result class. Reimplemented from ACE_Proactor_Impl.

ACE_Asynch_Result_Impl * ACE_WIN32_Proactor::create_asynch_timer ( | ACE_Handler & handler,
| const void * act,
| const ACE_Time_Value & tv,
| ACE_HANDLE event,
| int priority,
| int signal_number = 0 )`[virtual]`

| Create a timer result object which can be used with the Timer mechanism of the Proactor. Reimplemented from ACE_Proactor_Impl.

ACE_Asynch_Transmit_File_Impl * ACE_WIN32_Proactor::create_asynch_transmit_file ( | void )`[virtual]`

| Create the correct implementation class for doing Asynch_Transmit_File. Reimplemented from ACE_Proactor_Impl.

ACE_Asynch_Transmit_File_Result_Impl * ACE_WIN32_Proactor::create_asynch_transmit_file_result ( | ACE_Handler & handler,
| ACE_HANDLE socket,
| ACE_HANDLE file,
| ACE_Asynch_Transmit_File::Header_And_Trailer * header_and_trailer,
| u_long bytes_to_write,
| u_long offset,
| u_long offset_high,
| u_long bytes_per_send,
| u_long flags,
| const void * act,
| ACE_HANDLE event,
| int priority,
| int signal_number = 0 )`[virtual]`

| Create the correct implementation class for ACE_Asynch_Transmit_File::Result. Reimplemented from ACE_Proactor_Impl.

ACE_Asynch_Write_Dgram_Impl * ACE_WIN32_Proactor::create_asynch_write_dgram ( | void )`[virtual]`

| Create the correct implementation class for doing Asynch_Write_Dgram. Reimplemented from ACE_Proactor_Impl.

ACE_Asynch_Write_Dgram_Result_Impl * ACE_WIN32_Proactor::create_asynch_write_dgram_result ( | ACE_Handler & handler,
| ACE_HANDLE handle,
| ACE_Message_Block * message_block,
| size_t bytes_to_write,
| int flags,
| const void * act,
| ACE_HANDLE event,
| int priority,
| int signal_number = 0 )`[virtual]`

| Create the correct implementation class for ACE_Asynch_Write_Dgram::Result. Reimplemented from ACE_Proactor_Impl.

ACE_Asynch_Write_File_Impl * ACE_WIN32_Proactor::create_asynch_write_file ( | void )`[virtual]`

| Create the correct implementation class for doing Asynch_Write_File. Reimplemented from ACE_Proactor_Impl.

ACE_Asynch_Write_File_Result_Impl * ACE_WIN32_Proactor::create_asynch_write_file_result ( | ACE_Handler & handler,
| ACE_HANDLE handle,
| ACE_Message_Block & message_block,
| u_long bytes_to_write,
| const void * act,
| u_long offset,
| u_long offset_high,
| ACE_HANDLE event,
| int priority,
| int signal_number = 0 )`[virtual]`

| Create the correct implementation class for ACE_Asynch_Write_File::Result. Reimplemented from ACE_Proactor_Impl.

ACE_Asynch_Write_Stream_Impl * ACE_WIN32_Proactor::create_asynch_write_stream ( | void )`[virtual]`

| Create the correct implementation class for doing Asynch_Write_Stream. Reimplemented from ACE_Proactor_Impl.

ACE_Asynch_Write_Stream_Result_Impl * ACE_WIN32_Proactor::create_asynch_write_stream_result ( | ACE_Handler & handler,
| ACE_HANDLE handle,
| ACE_Message_Block & message_block,
| u_long bytes_to_write,
| const void * act,
| ACE_HANDLE event,
| int priority,
| int signal_number = 0 )`[virtual]`

| Create the correct implementation class for ACE_Asynch_Write_Stream::Result. Reimplemented from ACE_Proactor_Impl.

ACE_HANDLE ACE_WIN32_Proactor::get_handle ( | void ) const`[virtual]`

| Get the event handle. Reimplemented from ACE_Proactor_Impl.

int ACE_WIN32_Proactor::handle_close ( | ACE_HANDLE handle,
| ACE_Reactor_Mask close_mask )`[protected, virtual]`

| Called when object is removed from the ACE_Reactor. Reimplemented from ACE_Event_Handler.

int ACE_WIN32_Proactor::handle_events ( | unsigned long milli_seconds )`[protected, virtual]`

| Dispatch a single set of events. If <milli_seconds> elapses before any events occur, return 0. Return 1 if a completion is dispatched. Return -1 on errors.

int ACE_WIN32_Proactor::handle_events ( | void )`[virtual]`

| Block indefinitely until at least one event is dispatched. Dispatch a single set of events. If <wait_time> elapses before any events occur, return 0. Return 1 on success i.e., when a completion is dispatched, non-zero (-1) on errors and errno is set accordingly. Reimplemented from ACE_Proactor_Impl.

int ACE_WIN32_Proactor::handle_events ( | ACE_Time_Value & wait_time )`[virtual]`

| Dispatch a single set of events. If <wait_time> elapses before any events occur, return 0. Return 1 on success i.e., when a completion is dispatched, non-zero (-1) on errors and errno is set accordingly. Reimplemented from ACE_Proactor_Impl.

int ACE_WIN32_Proactor::handle_signal ( | int signum,
| siginfo_t * siginfo = 0,
| ucontext_t * ucontext = 0 )`[protected, virtual]`

| Called when object is signaled by OS (either via UNIX signals or when a Win32 object becomes signaled). Reimplemented from ACE_Event_Handler.

void ACE_WIN32_Proactor::number_of_threads ( | size_t threads )`[virtual]`

| Reimplemented from ACE_Proactor_Impl.

size_t ACE_WIN32_Proactor::number_of_threads ( | void ) const`[virtual]`

| Number of thread used as a parameter to CreatIoCompletionPort. Reimplemented from ACE_Proactor_Impl.

int ACE_WIN32_Proactor::post_completion ( | ACE_WIN32_Asynch_Result * result )`[virtual]`

| Post a result to the completion port of the Proactor. If errors occur, the result will be deleted by this method. If successful, the result will be deleted by the Proactor when the result is removed from the completion port. Therefore, the result should have been dynamically allocated and should be orphaned by the user once this method is called.

int ACE_WIN32_Proactor::post_wakeup_completions ( | int how_many )`[protected, virtual]`

| Post <how_many> completions to the completion port so that all threads can wake up. This is used in conjunction with the <run_event_loop>. Reimplemented from ACE_Proactor_Impl.

int ACE_WIN32_Proactor::register_handle ( | ACE_HANDLE handle,
| const void * completion_key )`[virtual]`

| This method adds the <handle> to the I/O completion port. This function is a no-op function for Unix systems. Reimplemented from ACE_Proactor_Impl.

int ACE_WIN32_Proactor::wake_up_dispatch_threads ( | void )`[virtual]`

| Add wakeup dispatch threads (reinit). Reimplemented from ACE_Proactor_Impl.

## Member Data Documentation

ACE_HANDLE ACE_WIN32_Proactor::completion_port_`[protected]`

| Handle for the completion port. Unix doesnt have completion ports.

ACE_Auto_Event ACE_WIN32_Proactor::event_`[protected]`

| This event is used in conjunction with Reactor when we try to integrate the event loops of Reactor and the Proactor.

size_t ACE_WIN32_Proactor::number_of_threads_`[protected]`

| This number is passed to the <CreatIOCompletionPort> system call.

int ACE_WIN32_Proactor::used_with_reactor_event_loop_`[protected]`

| Flag that indicates whether we are used in conjunction with Reactor.

ACE_Handler ACE_WIN32_Proactor::wakeup_handler_`[protected]`

| Handler to handle the wakeups. This works in conjunction with the .

The documentation for this class was generated from the following files:

- WIN32_Proactor.h
- WIN32_Proactor.cpp